﻿@page "/matches"

@using Models.MatchData
@using Business.Repository.IRepository
@inject IMatchFutsalRepository MatchFutsalRepository
@inject IMatchCoreRepository MatchCoreRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Matches</h4>
    </div>
    <div class="col-3 offset-1">
        <NavLink href="@($"/matches/create")" class="btn btn-primary form-control">Add new match</NavLink>
    </div>
</div>

<div class="row mt-2 mb-5">
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                @*<ValidationSummary />*@
                @if (Matches.Any())
                {
                    @foreach (var match in Matches)
                    {
                        
                        <div class="row align-items-center text-center"  @onclick="() => NavigateToDetails(match.Id)">
                            <div class="col-5">
                                <p class="h5 text-secondary text-center"><strong>@match.TeamHome.Name</strong></p>
                            </div>
                            <div class="col-2">
                                @if (match.MatchStatus.Status.Equals("Scheduled"))
                                {
                                    <div class="row align-items-center">
                                        <div class="col-12">
                                            @match.Competition.Name - @match.Round.Name
                                        </div>
                                        <div class="col-12">
                                            @match.Date.ToString("dd.MM.yyyy")
                                        </div>
                                        <div class="col-12">
                                            @match.Date.ToString("HH:mm")
                                        </div>
                                    </div>
                                }
                                else if (match.MatchStatus.Status.Equals("Finished"))
                                {
                                    <div class="row align-items-center">
                                        <div class="col-12">
                                            @match.Competition.Name - @match.Round.Name
                                        </div>
                                        <div class="col-12">
                                            <p class="text-warning h5"><strong>@match.TeamHomeScore : @match.TeamAwayScore</strong></p>
                                        </div>
                                        <div class="col-12">
                                            @match.Date.ToString("dd.MM.yyyy") - @match.Date.ToString("HH:mm")
                                        </div>
                                    </div>
                                }
                                else if (match.MatchStatus.Status.Equals("Live"))
                                {
                                    <div class="row align-items-center">

                                        <div class="col-12 ">
                                            <span style="color: #3d9c27">Live: @match.Minute</span>'
                                        </div>
                                        <div class="col-12">
                                            @match.Competition.Name - @match.Round.Name
                                        </div>
                                        <div class="col-12">
                                            <p class="text-warning h5"><strong>@match.TeamHomeScore : @match.TeamAwayScore</strong></p>
                                        </div>
                                        <div class="col-12">
                                            @match.Date.ToString("dd.MM.yyyy") - @match.Date.ToString("HH:mm")
                                        </div>
                                    </div>
                                }
                            </div>
                            <div class="col-5">
                                <p class="h5 text-secondary text-center"><strong>@match.TeamAway.Name</strong></p>
                            </div>
                        </div>
                        @if (Matches.Count() > index)
                        {
                            index++;
                            <hr />
                        }
                    }
                }
                else
                {
                    <div class="row">
                        <div class="col-5">No records found</div>
                    </div>
                }

            </div>
        </div>
    </div>
</div>


<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    private IEnumerable<MatchCoreDTO> Matches { get; set; } = new List<MatchCoreDTO>();
    private int? DeleteMatchId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;
    private string CurrentSport { get; set; }
    private int CurrentSportId { get; set; }
    private int CurrentSeasonId { get; set; }
    private int index = 1;

    protected async override Task OnInitializedAsync()
    {
        CurrentSport = await localStorage.GetItemAsync<string>("sportName");
        CurrentSportId = await localStorage.GetItemAsync<int>("sportId");
        CurrentSeasonId = await localStorage.GetItemAsync<int>("seasonId");
        Matches = await MatchCoreRepository.GetAllMatchesFromSport(CurrentSportId, CurrentSeasonId);
    }

    private async Task HandleDelete(int matchId)
    {
        DeleteMatchId = matchId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteMatchId != null)
        {
            await MatchFutsalRepository.Delete(DeleteMatchId.Value);
            await JsRuntime.ToastrSuccess("Match deleted successfully!");
            Matches = await MatchCoreRepository.GetAllMatchesFromSport(CurrentSportId, CurrentSeasonId);
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
    public void NavigateToDetails(int matchCoreId)
    {
        NavigationManager.NavigateTo("/matches/"+ CurrentSport + "/" + matchCoreId, true);
    }
}

